import json
import os

import inventory_provider
from inventory_provider.tasks import worker

DEFAULT_REQUEST_HEADERS = {
    "Content-type": "application/json",
    "Accept": ["application/json"]
}



# def test_get_one_equipment_location(mocker, client):
#     mocked_redis = mocker.patch(
#         "inventory_provider.routes.common.get_redis")
#     mocked_hget = mocked_redis.return_value.hget
#     dummy_data = {
#         "absid": 1404,
#         "equipment_name": "pp-cz-e13b",
#         "pop_name": "Prague",
#         "pop_abbreviation": "pra",
#         "pop_site_id": "",
#         "country": "Czech Republic",
#         "longitude": 14.391738888889,
#         "latitude": 50.101847222222
#     }
#     mocked_hget.return_value = json.dumps(dummy_data)
#
#     rv = client.get(
#         '/opsdb/equipment-location/dummy-equipment',
#         headers=DEFAULT_REQUEST_HEADERS)
#     assert rv.status_code == 200
#     assert rv.is_json
#     assert dummy_data == json.loads(rv.data.decode("utf-8"))
#
#     mocked_hget.assert_called_with(
#         worker.equipment_locations_key,
#         "dummy-equipment"
#     )


def test_get_equipment_location(client_with_mocked_data):
    rv = client_with_mocked_data.get(
        '/opsdb/equipment-location',
        headers=DEFAULT_REQUEST_HEADERS)
    assert rv.status_code == 200
    assert rv.is_json
    # TODO: validate against schema


def test_get_interface_info(client_with_mocked_data):
    rv = client_with_mocked_data.get(
        '/opsdb/interfaces',
        headers=DEFAULT_REQUEST_HEADERS)
    assert rv.status_code == 200
    assert rv.is_json
    # TODO: validate against schema


def test_get_interface_info_for_equipment(client_with_mocked_data):
    rv = client_with_mocked_data.get(
        '/opsdb/interfaces/mx1.ams.nl.geant.net',
        headers=DEFAULT_REQUEST_HEADERS)
    assert rv.status_code == 200
    assert rv.is_json
    # TODO: validate against schema


def test_get_interface_info_for_equipment_and_interface(client_with_mocked_data):
    rv = client_with_mocked_data.get(
        '/opsdb/interfaces/mx1.ams.nl.geant.net/ae0.0',
        headers=DEFAULT_REQUEST_HEADERS)
    assert rv.status_code == 200
    assert rv.is_json
    # TODO: validate against schema


def test_get_children(client_with_mocked_data):
    rv = client_with_mocked_data.get(
        '/opsdb/circuit-hierarchy/children/12363',
        headers=DEFAULT_REQUEST_HEADERS)
    assert rv.status_code == 200
    assert rv.is_json
    # TODO: validate against schema


def test_get_parents(client_with_mocked_data):
    rv = client_with_mocked_data.get(
        '/opsdb/circuit-hierarchy/parents/11725',
        headers=DEFAULT_REQUEST_HEADERS)
    assert rv.status_code == 200
    assert rv.is_json
    # TODO: validate against schema
